# --- [ check.py ] -------------------------------------------------------------
#
# Prüft, ob ein Eingabestring mit einem existierenden AT-Command-String
# beginnt.
# Berechnet die Prüfsumme für einen Frame

at_cmds = {"DH" : "Destination Adress High",
           "DL" : "Destinatino Adress Low",
           "MY" : "16-Bit Network Adress",
           "MP" : "16-Bit Parent Network Adress",
           "NC" : "Number of Remaining Children",
           "SH" : "Serial Number High",
           "SL" : "Serial Number Low",
           "NI" : "Node Identifier",
           "SE" : "Source Endpoint",
           "DE" : "Destination Endpoint",
           "CL" : "Cluster Identifier",
           "NP" : "Maximum RF Payload Bytes",
           "DD" : "Device Type Identifier",
           "CH" : "Operating Channel",
           "ID" : "Extended PAN ID",
           "OP" : "Operating Extended PAN ID",
           "NH" : "Maximum Unicast Hops",
           "BH" : "Broadcast Hops",
           "OI" : "Operating 16-Bit PAN ID",
           "NT" : "Node Discovery Timeout",
           "NO" : "Network Discovery Options",
           "SC" : "Scan Channels",
           "SD" : "Scan Duration",
           "ZS" : "ZigBee Stack Profile",
           "NJ" : "Node Join Time",
           "JV" : "Channel Verfication",
           "NW" : "Network Watchdog Timeout",
           "JN" : "Join Notification",
           "AR" : "Aggregate Routing Notification",
           "EE" : "Encryption Enable",
           "EO" : "Encryption Options",
           "NK" : "Network Encrytion Key",
           "KY" : "Link Key",
           "PL" : " ",
           "PM" : " ",
           "DB" : " ",
           "PP" : " ",
           "AP" : " ",
           "AO" : " ",
           "BD" : " ",
           "NB" : " ",
           "SB" : " ",
           "RO" : " ",
           "D7" : " ",
           "D6" : " ",
           "IR" : " ",
           "IC" : " ",
           "P0" : " ",
           "P1" : " ",
           "P2" : " ",
           "P3" : " ",
           "D0" : " ",
           "D1" : " ",
           "D2" : " ",
           "D3" : " ",
           "D4" : " ",
           "D5" : " ",
           "D6" : " ",
           "D7" : " ",
           "D8" : " ",
           "LT" : " ",
           "PR" : " ",
           "RP" : " ",
           "%V" : " ",
           "V+" : " ",
           "TP" : " ",
           "VR" : " ",
           "HV" : " ",
           "AI" : " ",
          # "CT" : " ",
          # "CN" : " ",
          # "GT" : " ",
          # "CC" : " ",
           "SM" : " ",
           "SN" : " ",
           "SP" : " ",
           "ST" : " ",
           "SO" : " ",
           "WH" : " ",
           "SI" : " ",
           "PO" : " ",

           "AC" : " ",
           "WR" : " ",
           "RE" : " ",
           "FR" : " ",
           "NR" : " ",
           "SI" : " ",
           "CB" : " ",
           "ND" : " ",
           "DN" : " ",
           "IS" : " ",
           "1S" : " "}


def check_atcmd(cmd):
    """ Prüft, ob der String bestehend aus 2 Zeichen ein gültiges AT-Command
        darstellt.
        Wird das Cmd im Dictonary gefunden, dann wird das Cmd und der
        "Langtext" zurückgegeben.
        Wird kein gültiges AT-Command gefunden, dann wird ein Tupel
        aus 2 leere Strings zurückgegeben
    """

    cmd = cmd.upper()
    text = at_cmds.get(cmd, "?")
    if text == "?":             # dann wurde nichts gefunden
        cmd  = ""
        text = ""

    return (cmd, text)


def check_sum(cmd):
    """ liefert die Länge des Frame (incl. Prüfsumme) sowie
        die Prüfsumme für den Frame:
        Das erste Zeichen 0x7E und die beiden Längenbytes werden ausgelassen.
        Die Summe aller anderen Bytes (ab Byte 3) wird von 255 subtrahiert
        Die Summe ist vom Typ int, muss durch % 256 auf ein Byte reduziert
        werden.        
    """
    sum = 0
    l = len(cmd)
    for i in range(3, l):
        sum += cmd[i]
    return ( l - 3, (255 - (sum % 256)))


if __name__ == "__main__":

    while True:
        a = input("Eingabe : ")
        print(check_atcmd(a[:2]))

# --- [ eof ] ------------------------------------------------------------------
        
