# --- [ cl_combo.py ] ---------------------------------------------------------------------------------------------


import tkinter as Tk
from tkinter import ttk
import xbee_adr

class Combo(object):

    def __init__(self, master = None, column = 0, row = 0,height = 10, width = 20):

        self.last_selection = 0       
        self.master = master
        choice = xbee_adr.get_Station_Names()

        self.combo = ttk.Combobox(self.master, values=choice, state="readonly",
                                    height = height, width = width)
        self.combo.set(choice[self.last_selection])       
        self.combo.bind("<<ComboboxSelected>>", self._change_selection)
        self.combo.grid(column = column, row = row,padx = 5, pady = 5, sticky = "nswe")

    def _change_selection(self, event):
        """ Wird bei jeder Änderung aufgerufen und schreibt die aktuelle
            Auswahl in die Variable last_selection
        """
        j = event.widget.current()
        self.last_selection = j
#        print(event.widget.current())         
#        print(event.widget.get())
            
    def get_Idx(self):
        """ Gibt den Index der zuletzt erfolgten Auswahl zurück """
        return self.last_selection
    
    def change_list(self, new_list = None):
        """Die Liste der Combobox wird ausgetauscht, der Zeiger wieder auf die
           alte Position, es sei denn, die Liste ist kürzer geworden
        """
        if new_list == None:
              new_list = list(["12345", "34567", "7657567", "333333"])

        if len(new_list) < self.last_selection:
            self.last_selection = len(new_list) - 1
            
        self.combo.configure(values = new_list)
        self.combo.set(new_list[self.last_selection])

if __name__ == "__main__":

    def main():
        top = Tk.Tk()
        frm = Tk.Frame(top)
        frm.grid(column = 0, row = 0)
        f = open("xbee.cfg")
        xbee_adr.read_adr(f)
        f.close()
        
        app = Combo(master = frm, height = 30)
        top.title("ttk Combobox")
        top.mainloop()

    main()
