# --- [ ListBox.py ] --------------------------------------------------------
import tkinter as Tk
#from tkinter import ttk
import _thread
import time

    
# -------------------------------------------------------------------------

class My_Listbox(Tk.Listbox):

    def __init__(self, master,
                 listvar = "? ?",
                 width = 15,
                 height = 10,
                 font = ("courier",10),
                 selectbackground = "black",
                 activestyle = "dotbox",
                 callback = None,
                 **kw):

        Tk.Listbox.__init__(self, master,
                         width = width,
                         height = height,
                         font = font,
                         selectbackground = selectbackground,
                         activestyle = activestyle,
                         **kw)
        self.__callback = callback
        self.__variable = Tk.StringVar()
        self.__variable.set(listvar)
        self.config(listvariable = self.__variable)
        
        self.__cursor = 0                   # Auswahl auf das erste Element
        self.selection_set(self.__cursor)

        self.bind("<Button-1>", self.__listbox_select)

                  
    def set_ListVar(self, listvar):
        self.cursor = 0
        self.selection_set(self.__cursor)
        self.__variable.set(listvar)

    def __listbox_select(self, event = None):
        try:
            self.__cursor = self.curselection()[0]
        except:
            self.__cursor = 0

        if  not self.__callback:
            print(event)
            return
        else:
            self.__callback(self.__cursor)
        

        
    def get_Selection(self):
        """ Liefert den Index der aktuellen Auswahl zurück """
        return self.__cursor


if __name__ == "__main__":

    def animate():
        time.sleep(5)       # nach 5 Sekunden wird die Liste ausgetauscht !!!        

        lb.set_ListVar("Specht Amsel Drossel Rotkehlchen")
        while True:
            time.sleep(1)

    def print_selection(element):
        print(element)

    top = Tk.Tk()
    top.title("OptionMenu-Test")

    frm1 = Tk.Frame(top)
    frm1.grid(column = 0, row = 0)

    lb = My_Listbox(frm1, callback = print_selection, listvar = ("Rot Grün Gelb Blau Violett Grau Bunt Hell"))
    lb.grid(column = 0, row = 0, padx = 5, pady = 5, sticky = "nsew")         

    #lb.set_ListVar("Specht Amsel Drossel Rotkehlchen")

    _thread.start_new_thread(animate,())
    
    top.mainloop()

# --- [ eof ] --------------------------------------------------------------
