# --- [ ttk_combo.py ] ---------------------------------------------------------------------------------------------

"""Ttk Theme Selector.

Although it is a theme selector, you won't notice many changes since
there is only a combobox and a frame around.
"""
import tkinter as Tk
from tkinter import ttk

class App(object):

    def __init__(self, master = None, height = 10, width = 12):
        #ttk.Frame.__init__(self, master = None, height = 10, width = 12)

        self.style = ttk.Style()
        self.style.configure("TButton", font = "Courier 12")
        self.style.configure("TkDefaultFont", font = "Courier")
       # self.style.configure("TCombobox", padding=6, relief="raised", foreground = "#000", background="#fff")
        self.style.configure("TCombobox", padding=6)
        #self.style.configure("TCombobox", font = "Courier 12")
        self.last_selection = 0
        
        
        self.master = master
        
        choice = list(["ABCDEFG", "abcdefg", "AaBbCcDdEe", "XYZABCD"])
        #themes.insert(0, "Pick a theme")
        # Create a readonly Combobox which will display 4 values at max,
        # which will cause it to create a scrollbar if there are more
        # than 4 values in total.
        self.combo = ttk.Combobox(self.master, values=choice, state="readonly",
                                    height = height, width = width)
        self.combo.set(choice[self.last_selection])
        # Combobox widget generates a <<ComboboxSelected>> virtual event
        # when the user selects an element. This event is generated after
        # the listbox is unposted (after you select an item, the combobox's
        # listbox disappears, then it is said that listbox is now unposted).
        
        self.combo.bind("<<ComboboxSelected>>", self._change_selection)
        self.combo.grid(column = 0, row = 0,padx = 5, pady = 5, sticky = "nswe")
        btn = ttk.Button(self.master, text = "ABDT", width = 12, command = self._change_list)
        btn.grid(column = 0, row = 1, padx = 5, pady = 5, sticky = "nsew")
        #self.style.configure("TButton", font = "Courier 12 bold")

        print(self.style.layout('TCombobox'))
        print(self.style.lookup('TCombobox','TkDefaultFont'))
        print(self.style.lookup('TCombobox', 'font'))
        print(self.style.theme_names())
        print(self.style.theme_use())




    def _change_selection(self, event):

        j = event.widget.current()
        if j >= 0:
        #if event.widget.current(): # value #0 is not a theme
            print(event.widget.current())         
            print(event.widget.get())
            
    def _change_list(self, new_list = None):
        """Die Liste der Combobox wird ausgetauscht, der Zeiger wieder auf die
           alte Position, es sei denn, die Liste ist kürzer geworden

        """
        if new_list == None:
              new_list = list(["12345", "34567", "7657567", "333333"])

        if len(new_list) < self.last_selection:
            self.last_selection = len(new_list)
            
        self.combo.configure(values = new_list)
        self.combo.set(new_list[self.last_selection])



if __name__ == "__main__":

    def main():
        top = Tk.Tk()
        frm = Tk.Frame(top)
        frm.grid(column = 0, row = 0)
        
        app = App(master = frm)
        top.title("Ttk Combobox")
        top.mainloop()


    main()
