# --- [ xbee_main.py ] ---------------------------------------------------------


from tkinter import *
from tkinter import filedialog
from tkinter import ttk
import time
import serial
import receive
import _thread
import inputs
import frames
import xbee_adr
import cl_edit
import config
import xbee_adr
import read_cfg
import xbee_list


class Register_Data():
    
    def __init__(self, master, optionlist):
        inputs.Input_0x10(master, column = 0, row = 0, optionlist = optionlist)
        inputs.Input_0x10(master, column = 0, row = 1, optionlist = optionlist)
        inputs.Input_0x10(master, column = 0, row = 2, optionlist = optionlist)
        inputs.Input_0x10(master, column = 0, row = 3, optionlist = optionlist)
        
class Register_Remote_At():
    
    def __init__(self, master, optionlist):
        inputs.Input_0x17(master, column = 0, row = 0, optionlist = optionlist)
        inputs.Input_0x17(master, column = 0, row = 1, optionlist = optionlist)
        inputs.Input_0x17(master, column = 0, row = 2, optionlist = optionlist)
        inputs.Input_0x17(master, column = 0, row = 3, optionlist = optionlist)
        
class Register_Local_At():
    
    def __init__(self, master):
        inputs.Input_0x08(master, column = 0, row = 0)
        inputs.Input_0x08(master, column = 0, row = 1)
        inputs.Input_0x08(master, column = 0, row = 2)
        inputs.Input_0x08(master, column = 0, row = 3)     
        
class app(object):
    
    def __init__(self):
        self.top = Tk()
        self.top.resizable(width = False, height = False) # Größe nicht veränderbar

        self.comport, self.tx_width, self.tx_height, self.tm_dez = read_cfg.read_cfg()
    
        if self.comport == None:
            self.comportname = "no ComPort !"
        else:
            self.comportname = self.comport.name
            
        self.title = "XBee API-Tool @ "+ self.comportname
        self.top.title(self.title)
        self.top.bind("<Destroy>", self.top_quit)

##        self.Standard_Font = ("Arial", 8)
##        self.Entry_Font    = ("Courier", 10, "bold")
        self.Editor_Font   = ("Courier", 10, "bold" )
##
##        # ohne Funktion für: Optionmenu, Labelframe, notebook
##        # für Optionmenu ist ein "workaround" über .config() eingebaut
##        self.top.option_add("*Label*font", self.Standard_Font)
##        self.top.option_add("*LabelFrame*font", self.Standard_Font)
##        self.top.option_add("*Button*font", self.Standard_Font)
##        self.top.option_add("*Entry*font", self.Entry_Font)
##        self.top.option_add("*Radiobutton*font", self.Standard_Font)
##        self.top.option_add("*Checkbutton*font", self.Standard_Font)
        self.top.option_add("*Text*font", self.Editor_Font)

        # hier kann der Font für Buttons, Labels etc. verändert werden
        #self.style = ttk.Style()
        #self.style.configure('.', font = "Arial 8")
        
        self.frm1 = Frame(self.top)
        self.frm1.grid(column = 0, row = 0, padx = 5, pady = 5)

        self.handle = None          # Filehandle
        self.add_Menuleiste()
        self.add_MenuDatei()
        self.add_MenuKonfig()
        
        self.config_app(self.frm1)
        self.add_Notebook(self.frm1, xbee_adr.adr_names)

        frames.tx1     = self.tx1
        frames.tx2     = self.tx2
        frames.tm_dez  = self.tm_dez
        receive.tm_dez = self.tm_dez
        inputs.tm_dez  = self.tm_dez
        inputs.tx1     = self.tx1
        inputs.tx2     = self.tx2
        xbee_adr.tx    = self.tx1
        inputs.comport = self.comport

        # der Thread, der für den Empfang Serieller Daten zuständig ist
        _thread.start_new_thread(receive.Serial_Read_Thread,(self.comport,))

        config.TX_Register.put_Values() # Die Grundeinstellungen 
        config.RX_Register.put_Values()
        
        self.top.mainloop()

    def config_app(self, frm1):
        self.tx1 = cl_edit.Editor(frm1, column = 2, row = 0, width = 80,
                                  height = self.tx_height - 12, xscroll = True)
        self.tx2 = cl_edit.Editor(frm1, column = 0, row = 0, width = self.tx_width,
                                  height = self.tx_height, rowspan = 3, xscroll = True)

    def add_Notebook(self, parent, optionlist):
        self.nb = ttk.Notebook(parent, width=630, height=150)
        self.reg1 = Frame(self.nb)
        self.reg2 = Frame(self.nb)
        self.reg3 = Frame(self.nb)
        self.nb.add(self.reg1, text='  Data Frames - 0x10  ',      padding = 5, sticky = "ewns")    
        self.nb.add(self.reg2, text='  Remote AT Frames - 0x17  ', padding = 5, sticky = "ewns")
        self.nb.add(self.reg3, text='  Local AT Frames - 0x08  ',  padding = 5, sticky = "ewsn")

        self.nb.grid(column = 2, row = 2, columnspan = 2, rowspan = 2) 
        Register_Data(     self.reg1, optionlist)
        Register_Remote_At(self.reg2, optionlist)
        Register_Local_At( self.reg3)


    def add_Menuleiste(self):
        self.menuleiste = Menu(self.top)
        self.top.configure(menu = self.menuleiste)

    def add_MenuDatei(self):
        self.dateimenu = Menu(self.menuleiste)

        self.dateimenu.add_command(label = "Leeres LogFile anlegen", command = self.new_Log)
        self.dateimenu.add_command(label = "An bestehendes LogFile anhängen", command = self.append_Log)
        self.dateimenu.add_separator()
        self.dateimenu.add_command(label = "LogFile schließen", command = self.close_Log)
        self.dateimenu.add_separator()
        self.dateimenu.add_command(label = "Beenden", command = self.ende)

        self.menuleiste.add_cascade(label = "Datei", menu = self.dateimenu)

    def add_MenuKonfig(self):
        self.dateimenu = Menu(self.menuleiste)

        self.dateimenu.add_command(label = "Einstellungen", command = self.cfg)
        self.dateimenu.add_separator()
        self.dateimenu.add_command(label = "Device-Liste", command = self.xbee_liste)

        self.menuleiste.add_cascade(label = "Optionen", menu = self.dateimenu)

    def new_Log(self):
        self.path = filedialog.asksaveasfilename(
            title = "Neue LogDatei anlegen",
            defaultextension = "log",
            initialfile = "data",
            filetypes = [("log","*.log")])
        if len(self.path):
            self.handle = open(self.path, mode = "w")
            self.top.title(self.title + " - LogFile: " + self.path)
            inputs.file_handle = self.handle
            frames.file_handle = self.handle

    def append_Log(self):
        self.path = filedialog.askopenfilename(
            title = "An bestehende LogDatei anhängen",
            defaultextension = "log",
            initialfile = "data",
            filetypes = [("log","*.log")])
        if len(self.path):
            self.handle = open(self.path, mode = "a")
            self.top.title(self.title + " - LogFile: " + self.path)
            inputs.file_handle = self.handle
            frames.file_handle = self.handle

    def close_Log(self):
        if not self.handle == None:
            self.handle.close()
            self.handle = None
            self.top.title( self.title)
            inputs.file_handle = None
            frames.file_handle = None
        
    def top_quit(self, event = None):
        """ Wenn das App-Window mit dem Button oben rechts geschlossen wird
            muss eine ggf. geöffnete Datei noch geschlossen werden
        """
        if not self.handle == None:
            self.handle.close()
            self.handle = None
        
    def ende(self):
        """ Beendet die Applikation durch einen Button/Menüauswahl
            ggf. muss noch eine Datei geschlossen werden
        """
        if not self.handle == None:
            self.handle.close()
            self.handle = None
        self.top.destroy()
        
    def cfg(self):
        config.einstellungen(parent = self.top)

    def xbee_liste(self):
        xbee_list.xbee_list(parent = self.top)

if __name__ == "__main__":

    app()
    
# --- [ eof ] ------------------------------------------------------------------
